diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/argsresources.c vnc_unixsrc/vncviewer/argsresources.c
--- vnc_unixsrc.orig/vncviewer/argsresources.c	2007-02-04 17:10:31.000000000 -0500
+++ vnc_unixsrc/vncviewer/argsresources.c	2010-04-18 12:39:55.000000000 -0400
@@ -343,77 +1548,247 @@
  * not already processed by XtVaAppInitialize().  It sets vncServerHost and
  * vncServerPort and all the fields in appData.
  */
+extern int saw_appshare;
 
 void
 GetArgsAndResources(int argc, char **argv)
 {
-  int i;
-  char *vncServerName, *colonPos;
-  int len, portOffset;
+	char *vncServerName = NULL, *colonPos, *bracketPos;
+	int len, portOffset;
+	int disp;
 
   /* Turn app resource specs into our appData structure for the rest of the
      program to use */
 
-  XtGetApplicationResources(toplevel, &appData, appDataResourceList,
-			    XtNumber(appDataResourceList), 0, 0);
+	XtGetApplicationResources(toplevel, &appData, appDataResourceList,
+	    XtNumber(appDataResourceList), 0, 0);
+
+	/*
+	 * we allow setting of some by env, to avoid clash with other
+	 * viewer's cmdlines (e.g. change viewer in SSVNC).
+	 */
+	if (getenv("VNCVIEWER_ALPHABLEND")) {
+		appData.useCursorAlpha = True;
+	}
+	if (getenv("VNCVIEWER_POPUP_FIX")) {
+		if (getenv("NOPOPUPFIX")) {
+			;
+		} else if (!strcmp(getenv("VNCVIEWER_POPUP_FIX"), "0")) {
+			;
+		} else {
+			appData.popupFix = True;
+		}
+	}
+	if (getenv("VNCVIEWER_GRAB_SERVER")) {
+		appData.grabAll = True;
+	}
+	if (getenv("VNCVIEWER_YCROP")) {
+		int n = atoi(getenv("VNCVIEWER_YCROP"));
+		if (n != 0) {
+			appData.yCrop = n;
+		}
+	}
+	if (getenv("VNCVIEWER_RFBVERSION") && strcmp(getenv("VNCVIEWER_RFBVERSION"), "")) {
+		appData.rfbVersion = strdup(getenv("VNCVIEWER_RFBVERSION"));
+	}
+	if (getenv("VNCVIEWER_ENCODINGS") && strcmp(getenv("VNCVIEWER_ENCODINGS"), "")) {
+		appData.encodingsString = strdup(getenv("VNCVIEWER_ENCODINGS"));
+	}
+	if (getenv("VNCVIEWER_NOBELL")) {
+		appData.useBell = False;
+	}
+	if (getenv("VNCVIEWER_X11CURSOR")) {
+		appData.useX11Cursor = True;
+	}
+	if (getenv("VNCVIEWER_RAWLOCAL")) {
+		appData.useRawLocal = True;
+	}
+	if (getenv("VNCVIEWER_NOTTY") || getenv("SSVNC_VNCVIEWER_NOTTY")) {
+		appData.notty = True;
+	}
+	if (getenv("VNCVIEWER_SBWIDTH")) {
+		int n = atoi(getenv("VNCVIEWER_SBWIDTH"));
+		if (n != 0) {
+			appData.sbWidth = n;
+		}
+	}
+	if (getenv("VNCVIEWER_ULTRADSM")) {
+		appData.ultraDSM = True;
+	}
+	if (getenv("SSVNC_ULTRA_DSM") && strcmp(getenv("SSVNC_ULTRA_DSM"), "")) {
+		appData.ultraDSM = True;
+	}
+	if (getenv("SSVNC_NO_ULTRA_DSM")) {
+		appData.ultraDSM = False;
+	}
+	if (getenv("SSVNC_SCALE") && strcmp(getenv("SSVNC_SCALE"), "")) {
+		if (appData.scale == NULL) {
+			appData.scale = strdup(getenv("SSVNC_SCALE"));
+		}
+	}
+	if (getenv("VNCVIEWER_ESCAPE") && strcmp(getenv("VNCVIEWER_ESCAPE"), "")) {
+		if (appData.escapeKeys == NULL) {
+			appData.escapeKeys = strdup(getenv("VNCVIEWER_ESCAPE"));
+		}
+	}
+	if (saw_appshare) {
+		appData.appShare = True;
+	}
+	if (appData.appShare && appData.escapeKeys == NULL) {
+		appData.escapeKeys = strdup("default");
+	}
+	if (appData.escapeKeys != NULL) {
+		appData.escapeActive = True;
+	}
+	if (getenv("VNCVIEWER_SEND_CLIPBOARD")) {
+		appData.sendClipboard = True;
+	}
+	if (getenv("VNCVIEWER_SEND_ALWAYS")) {
+		appData.sendAlways = True;
+	}
+	if (getenv("VNCVIEWER_RECV_TEXT")) {
+		char *s = getenv("VNCVIEWER_RECV_TEXT");
+		if (!strcasecmp(s, "clipboard")) {
+			appData.recvText = strdup("clipboard");
+		} else if (!strcasecmp(s, "primary")) {
+			appData.recvText = strdup("primary");
+		} else if (!strcasecmp(s, "both")) {
+			appData.recvText = strdup("both");
+		}
+	}
+	if (getenv("VNCVIEWER_PIPELINE_UPDATES")) {
+		appData.pipelineUpdates = True;
+	} else if (getenv("VNCVIEWER_NO_PIPELINE_UPDATES")) {
+		appData.pipelineUpdates = False;
+	}
+
+	if (getenv("VNCVIEWER_NO_IPV4")) {
+		appData.noipv4 = True;
+	}
+	if (getenv("VNCVIEWER_NO_IPV6")) {
+		appData.noipv6 = True;
+	}
+
+	if (appData.useBGR233 && appData.useBGR565) {
+		appData.useBGR233 = 0;
+	}
+
+	if (getenv("SSVNC_ULTRA_FTP_JAR") == NULL && programName != NULL) {
+		int len = strlen(programName) + 200;
+		char *q, *jar = (char *) malloc(len);
+		
+		sprintf(jar, "%s", programName);
+		q = strrchr(jar, '/');
+		if (q) {
+			struct stat sb;
+			*(q+1) = '\0';
+			strcat(jar, "../lib/ssvnc/util/ultraftp.jar");
+			if (stat(jar, &sb) == 0) {
+				char *put = (char *) malloc(len);
+				sprintf(put, "SSVNC_ULTRA_FTP_JAR=%s", jar);
+				fprintf(stderr, "Setting: %s\n\n", put);
+				putenv(put);
+			} else {
+				sprintf(jar, "%s", programName);
+				q = strrchr(jar, '/');
+				*(q+1) = '\0';
+				strcat(jar, "util/ultraftp.jar");
+				if (stat(jar, &sb) == 0) {
+					char *put = (char *) malloc(len);
+					sprintf(put, "SSVNC_ULTRA_FTP_JAR=%s", jar);
+					fprintf(stderr, "Setting: %s\n\n", put);
+					putenv(put);
+				}
+			}
+		}
+		free(jar);
+	}
+
 
   /* Add our actions to the actions table so they can be used in widget
      resource specs */
 
-  XtAppAddActions(appContext, actions, XtNumber(actions));
+	XtAppAddActions(appContext, actions, XtNumber(actions));
 
   /* Check any remaining command-line arguments.  If -listen was specified
      there should be none.  Otherwise the only argument should be the VNC
      server name.  If not given then pop up a dialog box and wait for the
      server name to be entered. */
 
-  if (listenSpecified) {
-    if (argc != 1) {
-      fprintf(stderr,"\n%s -listen: invalid command line argument: %s\n",
-	      programName, argv[1]);
-      usage();
-    }
-    return;
-  }
-
-  if (argc == 1) {
-    vncServerName = DoServerDialog();
-    appData.passwordDialog = True;
-  } else if (argc != 2) {
-    usage();
-  } else {
-    vncServerName = argv[1];
-
-    if (!isatty(0))
-      appData.passwordDialog = True;
-    if (vncServerName[0] == '-')
-      usage();
-  }
-
-  if (strlen(vncServerName) > 255) {
-    fprintf(stderr,"VNC server name too long\n");
-    exit(1);
-  }
-
-  colonPos = strchr(vncServerName, ':');
-  if (colonPos == NULL) {
-    /* No colon -- use default port number */
-    strcpy(vncServerHost, vncServerName);
-    vncServerPort = SERVER_PORT_OFFSET;
-  } else {
-    memcpy(vncServerHost, vncServerName, colonPos - vncServerName);
-    vncServerHost[colonPos - vncServerName] = '\0';
-    len = strlen(colonPos + 1);
-    portOffset = SERVER_PORT_OFFSET;
-    if (colonPos[1] == ':') {
-      /* Two colons -- interpret as a port number */
-      colonPos++;
-      len--;
-      portOffset = 0;
-    }
-    if (!len || strspn(colonPos + 1, "0123456789") != len) {
-      usage();
-    }
-    vncServerPort = atoi(colonPos + 1) + portOffset;
-  }
+	if (listenSpecified) {
+		if (argc != 1) {
+			fprintf(stderr,"\n%s -listen: invalid command line argument: %s\n",
+			programName, argv[1]);
+			usage();
+		}
+		return;
+	}
+
+	if (argc == 1) {
+		vncServerName = DoServerDialog();
+		if (!use_tty()) {
+			appData.passwordDialog = True;
+		}
+	} else if (argc != 2) {
+		usage();
+	} else {
+		vncServerName = argv[1];
+
+		if (!use_tty()) {
+			appData.passwordDialog = True;
+		}
+		if (vncServerName[0] == '-') {
+			usage();
+		}
+	}
+
+	if (strlen(vncServerName) > 255) {
+		fprintf(stderr,"VNC server name too long\n");
+		exit(1);
+	}
+
+	colonPos = strrchr(vncServerName, ':');
+	bracketPos = strrchr(vncServerName, ']');
+	if (strstr(vncServerName, "exec=") == vncServerName) {
+		/* special exec-external-command case */
+		strcpy(vncServerHost, vncServerName);
+		vncServerPort = SERVER_PORT_OFFSET;
+	} else if (strstr(vncServerName, "fd=") == vncServerName) {
+		/* special exec-external-command case */
+		strcpy(vncServerHost, vncServerName);
+		vncServerPort = SERVER_PORT_OFFSET;
+	} else if (colonPos == NULL) {
+		/* No colon -- use default port number */
+		strcpy(vncServerHost, vncServerName);
+		vncServerPort = SERVER_PORT_OFFSET;
+	} else if (bracketPos != NULL && colonPos < bracketPos) {
+		strcpy(vncServerHost, vncServerName);
+		vncServerPort = SERVER_PORT_OFFSET;
+	} else {
+		if (colonPos > vncServerName && *(colonPos - 1) == ':') {
+			colonPos--;
+		}
+		memcpy(vncServerHost, vncServerName, colonPos - vncServerName);
+		vncServerHost[colonPos - vncServerName] = '\0';
+		len = strlen(colonPos + 1);
+		portOffset = SERVER_PORT_OFFSET;
+		if (colonPos[1] == ':') {
+			/* Two colons -- interpret as a port number */
+			colonPos++;
+			len--;
+			portOffset = 0;
+		}
+		if (!len || strspn(colonPos + 1, "0123456789") != (size_t) len) {
+			usage();
+		}
+#if 0
+		vncServerPort = atoi(colonPos + 1) + portOffset;
+#else
+		disp = atoi(colonPos + 1);
+		if (portOffset != 0 && disp >= 100) {
+			portOffset = 0;
+		}
+		vncServerPort = disp + portOffset;
+#endif
+	}
 }
diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/colour.c vnc_unixsrc/vncviewer/colour.c
--- vnc_unixsrc.orig/vncviewer/colour.c	2002-04-30 09:07:31.000000000 -0400
+++ vnc_unixsrc/vncviewer/colour.c	2010-02-25 22:02:19.000000000 -0500
@@ -31,9 +31,12 @@
 #define BGR233_SIZE 256
 unsigned long BGR233ToPixel[BGR233_SIZE];
 
+#define BGR565_SIZE 65536
+unsigned long BGR565ToPixel[BGR565_SIZE];
+
 Colormap cmap;
 Visual *vis;
-unsigned int visdepth, visbpp;
+unsigned int visdepth, visbpp, isLSB;
 Bool allocColorFailed = False;
 
 static int nBGR233ColoursAllocated;
@@ -45,6 +48,8 @@
 static void AllocateExactBGR233Colours();
 static Bool AllocateBGR233Colour(int r, int g, int b);
 
+static void SetupBGR565Map(unsigned long red_mask, unsigned long green_mask, unsigned long blue_mask);
+
 
 /*
  * SetVisualAndCmap() deals with the wonderful world of X "visuals" (which are
@@ -97,6 +102,44 @@
   visbpp = GetBPPForDepth(visdepth);
   cmap = DefaultColormap(dpy,DefaultScreen(dpy));
 
+  if (ImageByteOrder(dpy) == LSBFirst) {
+  	isLSB = 1;
+  } else {
+  	isLSB = 0;
+  }
+  if (visbpp == 24) {
+  	if (!appData.useBGR233) {
+  		fprintf(stderr, "Warning: for 24bpp enabling -bgr565 -- Don't use FullColor!\n"); 
+  		appData.useBGR565 = True;
+  	} else {
+  		fprintf(stderr, "Warning: for 24bpp using -bgr233 -- Don't use FullColor!\n"); 
+  	}
+  }
+
+  if (appData.useBGR565) {
+  	if (visdepth < 24 || visbpp < 24 || vis->class != TrueColor) {
+  		fprintf(stderr, "disabling -16bpp BGR565 on non-depth 24 machine\n"); 
+		appData.useBGR565 = False;
+  	} else {
+		myFormat.bitsPerPixel = 16;
+		myFormat.depth = 16;
+		myFormat.trueColour = 1;
+		myFormat.bigEndian = 0;
+		myFormat.redMax   = 31;
+		myFormat.greenMax = 63;
+		myFormat.blueMax  = 31;
+		myFormat.redShift   = 11;
+		myFormat.greenShift = 5;
+		myFormat.blueShift  = 0;
+
+		fprintf(stderr, "Using default colormap and translating from BGR565 (65536 colors).  Pixel format:\n");
+		PrintPixelFormat(&myFormat);
+
+		SetupBGR565Map(vis->red_mask, vis->green_mask, vis->blue_mask);
+		return;
+  	}
+  }
+
   if (!appData.useBGR233 && (vis->class == TrueColor)) {
 
     myFormat.bitsPerPixel = visbpp;
@@ -116,21 +159,42 @@
     return;
   }
 
-  appData.useBGR233 = True;
+  if (appData.useBGR233 == 0) {
+	appData.useBGR233 = 256;
+  }
 
   myFormat.bitsPerPixel = 8;
   myFormat.depth = 8;
   myFormat.trueColour = 1;
   myFormat.bigEndian = 0;
-  myFormat.redMax = 7;
+  myFormat.redMax   = 7;
   myFormat.greenMax = 7;
-  myFormat.blueMax = 3;
-  myFormat.redShift = 0;
+  myFormat.blueMax  = 3;
+  myFormat.redShift   = 0;
   myFormat.greenShift = 3;
-  myFormat.blueShift = 6;
+  myFormat.blueShift  = 6;
+
+	if (appData.useBGR233 == 64) {
+		/* BGR222 */
+		myFormat.redMax   = 3;
+		myFormat.greenMax = 3;
+		myFormat.blueMax  = 3;
+		myFormat.redShift   = 0;
+		myFormat.greenShift = 2;
+		myFormat.blueShift  = 4;
+	}
+	if (appData.useBGR233 == 8) {
+		/* BGR111 */
+		myFormat.redMax   = 2;
+		myFormat.greenMax = 2;
+		myFormat.blueMax  = 2;
+		myFormat.redShift   = 0;
+		myFormat.greenShift = 1;
+		myFormat.blueShift  = 2;
+	}
 
   fprintf(stderr,
-       "Using default colormap and translating from BGR233.  Pixel format:\n");
+       "Using default colormap and translating from BGR233 (%d colors).  Pixel format:\n", appData.useBGR233);
   PrintPixelFormat(&myFormat);
 
   SetupBGR233Map();
@@ -282,8 +346,12 @@
   XFree(format);
 
   if (bpp != 1 && bpp != 8 && bpp != 16 && bpp != 32) {
-    fprintf(stderr,"Can't cope with %d bits-per-pixel.  Sorry.\n", bpp);
-    exit(1);
+	if (bpp == 24) {
+		fprintf(stderr,"Warning: 24 bits-per-pixel may have problems...\n");
+	} else {
+		fprintf(stderr,"Can't cope with %d bits-per-pixel.  Sorry.\n", bpp);
+		exit(1);
+	}
   }
 
   return bpp;
@@ -374,7 +442,7 @@
 	if (!exactBGR233[i] &&
 	    XAllocColor(dpy, cmap, &cmapEntry[i])) {
 
-	  if (cmapEntry[i].pixel == i) {
+	  if ((long) cmapEntry[i].pixel == i) {
 
 	    shared[i] = True; /* probably shared */
 
@@ -394,16 +462,43 @@
     for (r = 0; r < 8; r++) {
       for (g = 0; g < 8; g++) {
 	for (b = 0; b < 4; b++) {
-	  if (BGR233ToPixel[(b<<6) | (g<<3) | r] == INVALID_PIXEL) {
+		int bs = 6, gs = 3, rs = 0;
+		int bm = 3, gm = 7, rm = 7;
+		if (appData.useBGR233 == 64) {
+			bs = 4; gs = 2; rs = 0;
+			bm = 3; gm = 3; rm = 3;
+		}
+		if (appData.useBGR233 == 8) {
+			bs = 2; gs = 1; rs = 0;
+			bm = 1; gm = 1; rm = 1;
+		}
+		if ((b > bm || g > gm || r > rm)) {
+			continue;
+		}
+	  if (BGR233ToPixel[(b<<bs) | (g<<gs) | (r<<rs)] == INVALID_PIXEL) {
 
 	    unsigned long minDistance = ULONG_MAX;
 
 	    for (i = 0; i < cmapSize; i++) {
 	      if (exactBGR233[i] || shared[i]) {
-		unsigned long distance
-		  = (abs(cmapEntry[i].red - r * 65535 / 7)
-		     + abs(cmapEntry[i].green - g * 65535 / 7)
-		     + abs(cmapEntry[i].blue - b * 65535 / 3));
+		unsigned long distance;
+		int r1, g1, b1;
+		if (appData.useGreyScale) {
+			int ave;
+			ave = (r + g + 2*b)/3;
+			r1 = ave;
+			g1 = ave;
+			b1 = ave/2;
+		} else {
+			r1 = r;
+			g1 = g;
+			b1 = b;
+		}
+		distance
+		  = (  abs(cmapEntry[i].red   - r1 * 65535 / rm)
+		     + abs(cmapEntry[i].green - g1 * 65535 / gm)
+		     + abs(cmapEntry[i].blue  - b1 * 65535 / bm));
+
 
 		if (distance < minDistance) {
 		  minDistance = distance;
@@ -412,7 +507,7 @@
 	      }
 	    }
 
-	    BGR233ToPixel[(b<<6) | (g<<3) | r] = nearestPixel;
+	    BGR233ToPixel[(b<<bs) | (g<<gs) | (r<<rs)] = nearestPixel;
 	    if (shared[nearestPixel] && !usedAsNearest[nearestPixel])
 	      nSharedUsed++;
 	    usedAsNearest[nearestPixel] = True;
@@ -433,6 +528,59 @@
   }
 }
 
+static void
+SetupBGR565Map(unsigned long red_mask, unsigned long green_mask, unsigned long blue_mask)
+{
+  int r, g, b;
+  int r2, g2, b2;
+  long idx;
+  int cnt = 0;
+  unsigned long pixel = 0;
+
+    for (r = 0; r < 32; r++) {
+      for (g = 0; g < 64; g++) {
+	for (b = 0; b < 32; b++) {
+		int bs = 0, gs = 5, rs = 11;
+		int bm = 31, gm = 63, rm = 31;
+		if ((b > bm || g > gm || r > rm)) {
+			continue;
+		}
+		r2 = (255 * r) / rm;
+		g2 = (255 * g) / gm;
+		b2 = (255 * b) / bm;
+
+		pixel = (r2 << 16) | (g2 << 8) | (b2 << 0);
+		if (appData.useGreyScale) {
+			int ave;
+			int r1, g1, b1;
+			ave = (2*r + g + 2*b)/3;
+			r1 = ave/2;
+			g1 = ave;
+			b1 = ave/2;
+
+			r2 = (255 * r1) / rm;
+			g2 = (255 * g1) / gm;
+			b2 = (255 * b1) / bm;
+
+			pixel = (r2 << 16) | (g2 << 8) | (b2 << 0);
+		}
+
+		if (red_mask == 0xff) {
+			idx = (r<<bs) | (g<<gs) | (b<<rs);
+		} else {
+			idx = (b<<bs) | (g<<gs) | (r<<rs);
+		}
+		if (0) fprintf(stderr, "cnt: %5d idx: %lu pixel: 0x%08x\n", cnt, idx, (unsigned int) pixel);
+		BGR565ToPixel[idx] = pixel;
+		cnt++;
+	}
+      }
+    }
+	green_mask = 0;
+	blue_mask = 0;
+}
+
+
 
 /*
  * AllocateExactBGR233Colours() attempts to allocate each of the colours in the
@@ -484,8 +632,13 @@
     ri = rn;
     for (gi = 0; gi < gn; gi++) {
       for (bi = 0; bi < bn; bi++) {
-	if (!AllocateBGR233Colour(rv[ri], gv[gi], bv[bi]))
-	  return;
+	if (appData.useBGR233 == 64 && (bv[bi] > 3 || gv[gi] > 3 || rv[ri] > 3)) {
+		nBGR233ColoursAllocated++;
+	} else if (appData.useBGR233 == 8 && (bv[bi] > 1 || gv[gi] > 1 || rv[ri] > 1)) {
+		nBGR233ColoursAllocated++;
+	} else if (!AllocateBGR233Colour(rv[ri], gv[gi], bv[bi])) {
+		return;
+	}
       }
     }
     rn++;
@@ -496,8 +649,13 @@
     gi = gn;
     for (ri = 0; ri < rn; ri++) {
       for (bi = 0; bi < bn; bi++) {
-	if (!AllocateBGR233Colour(rv[ri], gv[gi], bv[bi]))
-	  return;
+	if (appData.useBGR233 == 64 && (bv[bi] > 3 || gv[gi] > 3 || rv[ri] > 3)) {
+		nBGR233ColoursAllocated++;
+	} else if (appData.useBGR233 == 8 && (bv[bi] > 1 || gv[gi] > 1 || rv[ri] > 1)) {
+		nBGR233ColoursAllocated++;
+	} else if (!AllocateBGR233Colour(rv[ri], gv[gi], bv[bi])) {
+	  	return;
+	}
       }
     }
     gn++;
@@ -507,8 +665,13 @@
       bi = bn;
       for (ri = 0; ri < rn; ri++) {
 	for (gi = 0; gi < gn; gi++) {
-	  if (!AllocateBGR233Colour(rv[ri], gv[gi], bv[bi]))
-	    return;
+	  if (appData.useBGR233 == 64 && (bv[bi] > 3 || gv[gi] > 3 || rv[ri] > 3)) {
+		nBGR233ColoursAllocated++;
+	  } else if (appData.useBGR233 == 8 && (bv[bi] > 1 || gv[gi] > 1 || rv[ri] > 1)) {
+		nBGR233ColoursAllocated++;
+	  } else if (!AllocateBGR233Colour(rv[ri], gv[gi], bv[bi])) {
+	    	return;
+	  }
 	}
       }
       bn++;
@@ -529,18 +692,36 @@
 AllocateBGR233Colour(int r, int g, int b)
 {
   XColor c;
+	int bs = 6, gs = 3, rs = 0;
+	int bm = 3, gm = 7, rm = 7;
 
   if (nBGR233ColoursAllocated >= appData.nColours)
     return False;
 
-  c.red = r * 65535 / 7;
-  c.green = g * 65535 / 7;
-  c.blue = b * 65535 / 3;
+	if (appData.useBGR233 == 64) {
+		bs = 4; gs = 2, rs = 0;
+		bm = 3; gm = 3; rm = 3;
+	}
+	if (appData.useBGR233 == 8) {
+		bs = 2; gs = 1, rs = 0;
+		bm = 1; gm = 1; rm = 1;
+	}
+
+	c.red =   r * 65535 / rm;
+	c.green = g * 65535 / gm;
+	c.blue =  b * 65535 / bm;
+	if (appData.useGreyScale) {
+		int ave;
+		ave = (c.red + c.green + c.blue)/3;
+		c.red   = ave;
+		c.green = ave;
+		c.blue  = ave;
+	}
 
   if (!XAllocColor(dpy, cmap, &c))
     return False;
 
-  BGR233ToPixel[(b<<6) | (g<<3) | r] = c.pixel;
+  BGR233ToPixel[(b<<bs) | (g<<gs) | r] = c.pixel;
 
   nBGR233ColoursAllocated++;
 
diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/corre.c vnc_unixsrc/vncviewer/corre.c
--- vnc_unixsrc.orig/vncviewer/corre.c	2000-06-11 08:00:53.000000000 -0400
+++ vnc_unixsrc/vncviewer/corre.c	2008-10-05 15:16:01.000000000 -0400
@@ -29,6 +29,18 @@
 #define HandleCoRREBPP CONCAT2E(HandleCoRRE,BPP)
 #define CARDBPP CONCAT2E(CARD,BPP)
 
+#define FillRectangle(x, y, w, h, color)  \
+	{ \
+		XGCValues _gcv; \
+		_gcv.foreground = color; \
+		if (!appData.useXserverBackingStore) { \
+			FillScreen(x, y, w, h, _gcv.foreground); \
+		} else { \
+			XChangeGC(dpy, gc, GCForeground, &_gcv); \
+			XFillRectangle(dpy, desktopWin, gc, x, y, w, h); \
+		} \
+	}
+
 static Bool
 HandleCoRREBPP (int rx, int ry, int rw, int rh)
 {
@@ -50,11 +62,19 @@
 #if (BPP == 8)
     gcv.foreground = (appData.useBGR233 ? BGR233ToPixel[pix] : pix);
 #else
+#if (BPP == 16)
+    gcv.foreground = (appData.useBGR565 ? BGR565ToPixel[pix] : pix);
+#else
     gcv.foreground = pix;
 #endif
+#endif
 
+#if 0
     XChangeGC(dpy, gc, GCForeground, &gcv);
     XFillRectangle(dpy, desktopWin, gc, rx, ry, rw, rh);
+#else
+    FillRectangle(rx, ry, rw, rh, gcv.foreground);
+#endif
 
     if (!ReadFromRFBServer(buffer, hdr.nSubrects * (4 + (BPP / 8))))
 	return False;
@@ -72,12 +92,22 @@
 #if (BPP == 8)
 	gcv.foreground = (appData.useBGR233 ? BGR233ToPixel[pix] : pix);
 #else
+#if (BPP == 16)
+	gcv.foreground = (appData.useBGR565 ? BGR565ToPixel[pix] : pix);
+#else
 	gcv.foreground = pix;
 #endif
+#endif
 
+#if 0
 	XChangeGC(dpy, gc, GCForeground, &gcv);
 	XFillRectangle(dpy, desktopWin, gc, rx + x, ry + y, w, h);
+#else
+	FillRectangle(rx + x, ry + y, w, h, gcv.foreground);
+#endif
     }
 
     return True;
 }
+
+#undef FillRectangle
diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/cp_it vnc_unixsrc/vncviewer/cp_it
--- vnc_unixsrc.orig/vncviewer/cp_it	1969-12-31 19:00:00.000000000 -0500
+++ vnc_unixsrc/vncviewer/cp_it	2009-03-06 20:02:05.000000000 -0500
@@ -0,0 +1,18 @@
+#!/bin/sh
+
+dest=/dist/bin/vncviewerz-1.3dev5-resize
+suc "cp -p $dest $dest.back; mv $dest $dest.unlink; mv $dest.back $dest; rm $dest.unlink"
+strip ./vncviewer
+cat   ./vncviewer > $dest
+touch -r ./vncviewer $dest 
+yy=/dist/src/apps/VNC/etc/libvncserver_cvs/expts/etv/ssvnc/bin/Linux.i686/vncviewer
+mv $yy $yy.unlink
+cp -p ./vncviewer $yy
+mv $yy.turbovnc $yy.unlink.turbovnc
+cp -p ./vncviewer $HOME/etv_col/Linux.i686
+cp -p ./vncviewer.turbovnc $yy.turbovnc
+cp -p ./vncviewer.turbovnc $HOME/etv_col/Linux.i686/vncviewer.turbovnc
+chmod 755 $yy*
+
+rm -f $yy.unlink*
+ls -l ./vncviewer* $dest $yy* $HOME/etv_col/Linux.i686/vncviewer*
